/****************************************************************************/
/*																			*/
/*		STK-7125 TvvO											*/
/*			C														*/
/*																			*/
/*			Copyright   :: At@vWFNg							*/
/*			Cpu         :: SH7125											*/
/*			Language    :: SH-C												*/
/*			File Name   :: main.c											*/
/*																			*/
/****************************************************************************/
#include <machine.h>
#include "7125s.h"
#include "common.h"
#include "timer.h"
#include "sci.h"

/* SW */
#define SW1BIT	0x00080				// PF bit7 (EVB SW1)
#define SWPORT	(PF.DRL.WORD)		// PF PORT
static unsigned short SW = SW1BIT;

/* PWMp */
volatile struct {
	unsigned short	duty;	// PWM duty
	unsigned int	sw;		// PMW switch 0!=off
} PWM;

/************************************/
/*	VAo͊֐			*/
/************************************/
void sputs(char *p)
{
	while(1) {
		if(*p==0x00) break;			// Null܂ŏo
		while(sci_putc(*p)) ;		// Mobt@tȂđ
		++p;
	}
}

/************************************/
/*	XCb`͊֐				*/
/************************************/
int swin(void)
{
    static  unsigned short keyold = SW1BIT;
    unsigned short tmp;

    tmp = SW;
    if(keyold != tmp) { // SW1͏ԕω
        if(tmp & SW1BIT) {   // SW1ꂽ
            keyold = tmp;
            return 1;       // L[͗L
        }
    }
    
    keyold = tmp;

    return 0;   // L[͖
}

/************************************/
/*	LEDPWM֐				*/
/*	timer_intR[obN		*/
/************************************/
void led_pwm(void)
{
	static	int	dir,scnt;

	if(!PWM.sw) {
		/* PWM DutyύX */
		if( dir == 0 ) ++PWM.duty;
		else --PWM.duty;

		/* PWM ݒ */
		if( PWM.duty >= PERIOD ) dir=1;
		if( PWM.duty == 0      ) dir=0;

		/* PWM l */
		MTU20.TGRA = PWM.duty;
	}

	/* 20msɃ|[g̊Ď */
	if(++scnt > 20) {
		scnt=0;
		SW = (SWPORT&SW1BIT);
	}
}

/************************************/
/*	MAIN֐						*/
/************************************/
int main(void)
{
	short	rd;

	/* STK-7125EVB̉zCOMɃI[vjObZ[Wo͂܂ */
	sputs("\n\r --- STK-7125/EVB Sample Program --- ");
	sputs(" 2008/02 (C) Alpha Project\n\r");

	/* LED PWMׂ̈̃R[obN֐o^܂         */
	/* 1msŁAtimer_intled_pwm֐ďo܂ */
	timer_callback(led_pwm);

	/* Ŗ[v */
	for (;;)
	{
		/* STK-7125EVB̉zCOM̓͂GR[obN܂   */
		/* nCp[^[~i̐ݒ́A38400,8,1,NɂĂ  */
		rd = sci_getc();
		if (rd != sciEmpty) {
			sci_putc((char)(rd));
		}

		/* STK-7125EVBSW1ꂽꍇPWMo͂ON/OFF܂  */
		/* LD1PWMɂ100mSDUTY10%ɕωĂ܂ */
		if(swin()) {
			PWM.sw = ~PWM.sw;
		}
	}

	return 0;
}
